#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GoldenTurtleTaskCFG.h"
std::auto_ptr<Fish_GoldenTurtleTaskCFG> Fish_GoldenTurtleTaskCFG::msSingleton(nullptr);

int Fish_GoldenTurtleTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GoldenTurtleTaskCFGData* Fish_GoldenTurtleTaskCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GoldenTurtleTaskCFGData>& Fish_GoldenTurtleTaskCFG::GetMapData()
{
	return mMapData;
}

void Fish_GoldenTurtleTaskCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GoldenTurtleTaskCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GoldenTurtleTaskCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mDesc = element->Attribute("Desc");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mAwardItemIDs = element->IntAttribute("AwardItemIDs");
		data.mAwardItemCounts = element->IntAttribute("AwardItemCounts");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GoldenTurtleTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GoldenTurtleTaskCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GoldenTurtleTaskCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GoldenTurtleTaskCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GoldenTurtleTaskCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readInt(L, "AwardItemCounts", data.mAwardItemCounts);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GoldenTurtleTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GoldenTurtleTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GoldenTurtleTaskCFG* Fish_GoldenTurtleTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GoldenTurtleTaskCFG());
	}
	return msSingleton.get();
}

void Fish_GoldenTurtleTaskCFG::Release()
{
	msSingleton.reset(nullptr);
}
